class Fracao
{
    private int Num, Den;
    private static boolean Erro = false;

    public static boolean DeuErro ()
    {
        return Fracao.Erro;
    }

    public void AssumaValor (int N, int D)
    {
        if (D == 0)
        {
            Fracao.Erro = true;
            return;
        }

        if (D < 0)
        {
            this.Num = -N;
            this.Den = -D;
        }
        else
        {
            this.Num = N;
            this.Den = D;
        }

        Fracao.Erro = false;
    }

    public String NaFormaDeString ()
    {
        Fracao.Erro = false;

        if (this.Num == this.Den)
            return "1";

        if (this.Num + this.Den == 0)
            return "-1";

        if (this.Num == 0 || this.Den == 1)
            return "" + this.Num;

        return this.Num + "/" + this.Den;
    }

    public void SomeSeCom (int I)
    {
        this.Num = this.Den * I + this.Num;

        Fracao.Erro = false;
    }

    public void SubtraiaDeSi (int I)
    {
        this.Num = this.Num - this.Den * I;

        Fracao.Erro = false;
    }  

    public void MultipliqueSePor (int I)
    {
        this.Num = this.Num * I;

        Fracao.Erro = false;
    }  

    public void DividaSePor (int I)
    {
        if (I == 0)
        {
            Fracao.Erro = true;
            return;
        }

        this.Den = this.Den * I;

        if (this.Den < 0)
        {
            this.Num = -this.Num;
            this.Den = -this.Den;
        }

        Fracao.Erro = false;
    }  
}

class TesteDeFracao
{
    public static void main (String V [])
    {
        Fracao F1 = new Fracao (),
               F2 = new Fracao ();

        F1.AssumaValor (1,2);
        F2.AssumaValor (3,5);

        System.out.println  ();

        System.out.print   (F1.NaFormaDeString ());
        F1.SomeSeCom       (7);
        System.out.println (" + 7 = " + F1.NaFormaDeString ());

        System.out.print    (F2.NaFormaDeString ());
        F2.SubtraiaDeSi     (7);
        System.out.println  (" - 7 = " + F2.NaFormaDeString ());

        System.out.print    (F1.NaFormaDeString ());
        F1.MultipliqueSePor (7);
        System.out.println  (" * 7 = " + F1.NaFormaDeString ());

        System.out.print   (F2.NaFormaDeString ());
        F2.DividaSePor     (7);
        System.out.println (" / 7 = " + F2.NaFormaDeString ());
    }
}