class Fracao
{
    private long Num, Den;
    private static boolean Erro = false;

    public static boolean DeuErro ()
    {
        return Fracao.Erro;
    }

    public void AssumaValor (long N, long D)
    {
        if (D == 0)
        {
            Fracao.Erro = true;
            return;
        }

        if (D < 0)
        {
            this.Num = -N;
            this.Den = -D;
        }
        else
        {
            this.Num = N;
            this.Den = D;
        }

        Fracao.Erro = false;
    }

    public String toString ()
    {
        Fracao.Erro = false;

        if (this.Num == this.Den)
            return "1";

        if (this.Num + this.Den == 0)
            return "-1";

        if (this.Num == 0 || this.Den == 1)
            return "" + this.Num;

        return this.Num + "/" + this.Den;
    }

    public Fracao Mais (Fracao F)
    {
        Fracao R = new Fracao ();

        R.Num = this.Num * F.Den +
                this.Den * F.Num;

        R.Den = this.Den * F.Den;

        Fracao.Erro = false;
        return R;
    }

    public Fracao Menos (Fracao F)
    {
        Fracao R = new Fracao ();

        R.Num = this.Num * F.Den -
                this.Den * F.Num;

        R.Den = this.Den * F.Den;

        Fracao.Erro = false;
        return R;
    }

    public Fracao Vezes (Fracao F)
    {
        Fracao R = new Fracao ();

        R.Num = this.Num * F.Num;
        R.Den = this.Den * F.Den;

        Fracao.Erro = false;
        return R;
    }

    public Fracao DivididoPor (Fracao F)
    {
        if (F.Num == 0)
        {
            Fracao.Erro = true;
            return null;
        }

        Fracao R = new Fracao ();

        R.Num = this.Num * F.Den;
        R.Den = this.Den * F.Num;

        if (R.Den < 0)
        {
            R.Num = -R.Num;
            R.Den = -R.Den;
        }

        Fracao.Erro = false;
        return R;
    }
}