class Fracao
{
    private long Num, Den;
    private static boolean Erro = false;

    public static boolean DeuErro ()
    {
        return Fracao.Erro;
    }

    public Fracao (long N, long D)
    {
        if (D == 0)
        {
            Fracao.Erro = true;
            return;
        }

        if (D < 0)
        {
            this.Num = -N;
            this.Den = -D;
        }
        else
        {
            this.Num = N;
            this.Den = D;
        }

        Fracao.Erro = false;
    }

    public Fracao (String S)
    {
        if (S.length () == 0)
        {
            Fracao.Erro = true;
            return;
        }

        if (S.charAt (0) == '/' || S.charAt (S.length () - 1) == '/')
        {
            Fracao.Erro = true;
            return;
        }

        if (S.length () == 1 &&
            (S.charAt (0) == '+' || S.charAt (0) == '-'))
        {
            Fracao.Erro = true;
            return;
        }

        if (S.length () >= 2)
            if ((S.charAt (0) == '+' || S.charAt (0) == '-') &&
                (S.charAt (1) <  '0' || S.charAt (1) >  '9'))
        {
            Fracao.Erro = true;
            return;
        }

        int    I     = 0;
        String Slong = "";

        if (S.charAt (I) == '+')
            I++;
        else
            if (S.charAt (I) == '-')
                Slong = Slong + S.charAt (I++);

        while (I < S.length ())
        {
            if (S.charAt (I) == '/')
                break;

            if (S.charAt (I) < '0' || S.charAt (I) > '9')
            {
                Fracao.Erro = true;
                return;
            }

            Slong = Slong + S.charAt (I++);
        }

        this.Num = Long.valueOf (Slong).longValue ();

        if (I++ == S.length ())
        {
            this.Den = 1;

            Erro = false;
            return;
        }

        Slong = "";

        if (S.charAt (I) == '+')
            I++;
        else
            if (S.charAt (I) == '-')
                Slong = Slong + S.charAt (I++);

        while (I < S.length ())
        {
            if (S.charAt (I) < '0' || S.charAt (I) > '9')
            {
                Fracao.Erro = true;
                return;
            }

            Slong = Slong + S.charAt (I++);
        }
        
        this.Den = Long.valueOf (Slong).longValue ();

        if (this.Den == 0)
        {
            Fracao.Erro = true;
            return;
        }

        if (this.Den < 0)
        {
            this.Num = -this.Num;
            this.Den = -this.Den;
        }

        Fracao.Erro = false;
    }

    public String toString ()
    {
        Fracao.Erro = false;

        if (this.Num == this.Den)
            return "1";

        if (this.Num + this.Den == 0)
            return "-1";

        if (this.Num == 0 || this.Den == 1)
            return "" + this.Num;

        return this.Num + "/" + this.Den;
    }

    public Fracao Mais (Fracao F)
    {
        long N = this.Num * F.Den +
                 this.Den * F.Num;

        long D = this.Den * F.Den;

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao Mais (long L)
    {
        long N = this.Num +
                 this.Den * L;

        long D = this.Den;

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao Menos (Fracao F)
    {
        long N = this.Num * F.Den -
                 this.Den * F.Num;

        long D = this.Den * F.Den;

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao Menos (long L)
    {
        long N = this.Num -
                 this.Den * L;

        long D = this.Den;

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao Vezes (Fracao F)
    {
        long N = this.Num * F.Num;
        long D = this.Den * F.Den;

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao Vezes (long L)
    {
        long N = this.Num * L;
        long D = this.Den;

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao DivididoPor (Fracao F)
    {
        if (F.Num == 0)
        {
            Fracao.Erro = true;
            return null;
        }

        long N = this.Num * F.Den;
        long D = this.Den * F.Num;

        if (D < 0)
        {
            N = -N;
            D = -D;
        }

        Fracao.Erro = false;
        return new Fracao (N,D);
    }

    public Fracao DivididoPor (long L)
    {
        if (L == 0)
        {
            Fracao.Erro = true;
            return null;
        }

        long N = this.Num;
        long D = this.Den * L;

        if (D < 0)
        {
            N = -N;
            D = -D;
        }

        Fracao.Erro = false;
        return new Fracao (N,D);
    }
}