class Agenda
{
    private int     QtosContatos = 0;
    private boolean Erro         = false;

    private String  Nome     [],
                    Telefone [];

    private int OndeEsta (String N)
    {
        int Inicio = 0, Final = this.QtosContatos - 1, Onde;

        while (Inicio <= Final)
        {
            Onde = (Inicio + Final) / 2;

            int Comparacao = N.compareTo (this.Nome [Onde]);

            if (Comparacao == 0)
                return Onde;
            else
                if (Comparacao < 0)
                    Final = Onde - 1;
                else
                    Inicio = Onde + 1;
        }

        return -1;
    }

    private int OndeGuardar (String N)
    {
        int Inicio     = 0,
            Final      = this.QtosContatos - 1,
            Onde       = 0,
            Comparacao = -1;

        while (Inicio <= Final)
        {
            Onde       = (Inicio + Final) / 2;
            Comparacao = N.compareTo (this.Nome [Onde]);

            if (Comparacao == 0)
                return -1;
            else
                if (Comparacao < 0)
                    Final = Onde - 1;
                else
                    Inicio = Onde + 1;
        }

        return Comparacao < 0? Onde: Onde + 1;
    }

    public Agenda (int C)
    {
        if (C <= 0)
        {
            this.Erro = true;
            return;
        }

        this.Nome      = new String [C];
        this.Telefone  = new String [C];

        this.Erro      = false;
    }

    public boolean ErroNoUltimoServico ()
    {
        return this.Erro;
    }

    public int Capacidade ()
    {
        this.Erro = false;
        return this.Nome.length;
    }

    public int QuantosContatos ()
    {
        this.Erro = false;
        return this.QtosContatos;
    }

    public boolean HaRegistroDoContato (String N)
    {
        this.Erro = false;
        return this.OndeEsta (N) != -1;
    }

    public void RegistreOContato (String N, String T)
    {
        if (this.QtosContatos == this.Nome.length)
        {
            this.Erro = true;
            return;
        }

        int Posicao = this.OndeGuardar (N);

        if (Posicao == -1)
        {
            this.Erro = true;
            return;
        }

        for (int I = this.QtosContatos - 1; I >= Posicao; I--)
        {
            this.Nome     [I+1] = this.Nome     [I];
            this.Telefone [I+1] = this.Telefone [I];
        }

        this.Nome     [Posicao] = N;
        this.Telefone [Posicao] = T;

        this.QtosContatos++;
        this.Erro = false;
    }    

    public String DigaMeONome (int P)
    {
        if (P < 0 || P >= this.QtosContatos)
        {
            this.Erro = true;
            return null;
        }

        this.Erro = false;
        return this.Nome [P];
    }

    public String DigaMeOTelefone (int P)
    {
        if (P < 0 || P >= this.QtosContatos)
        {
            this.Erro = true;
            return null;
        }

        this.Erro = false;
        return this.Telefone [P];
    }

    public String DigaMeOTelefoneDe (String N)
    {
        int Posicao = this.OndeEsta (N);

        if (Posicao == -1)
        {
            this.Erro = true;
            return null;
        }

        this.Erro = false;
        return this.Telefone [Posicao];
    }

    public void DescarteOContato (String N)
    {
        if (this.QtosContatos == 0)
        {
            this.Erro = true;
            return;
        }

        int Posicao = this.OndeEsta (N);

        if (Posicao == -1)
        {
            this.Erro = true;
            return;
        }

        int I;

        for (I = Posicao; I < this.QtosContatos - 1; I++)
        {
            this.Nome     [I] = this.Nome     [I+1];
            this.Telefone [I] = this.Telefone [I+1];
        }

        this.Nome     [I] = null;
        this.Telefone [I] = null;

        this.QtosContatos--;
        this.Erro = false;
    }    
}