package Listas;

public class Lista
{
    protected class Elem
    {
        private float Info;
        private Elem  Prox;

        public Elem (float I, Elem E)
        {
            this.Info = I;
            this.Prox = E;
        }

        public float SuaInfo ()
        {
            return this.Info;
        }

        public Elem SeuProx ()
        {
            return this.Prox;
        }

        public void AssumaProx (Elem E)
        {
            this.Prox = E;
        }
    }

    protected Elem    Prim = null;
    protected boolean Erro = false;

    public boolean ErroNoUltimoServico ()
    {
        return this.Erro;
    }

    public boolean Vazia ()
    {
        this.Erro = false;

        return this.Prim == null;
    }

    public void GuardeEmOrdem (float F)
    {
        Elem Novo = new Elem (F, null);

        if (this.Vazia ())
        {
            this.Prim = new Elem (F, null);
            return;
        }

        if (F < this.Prim.SuaInfo ())
        {
            this.Prim = new Elem (F, this.Prim);
            return;
        }

        Elem Ant, Atu;

        for (Ant = this.Prim, Atu = this.Prim.SeuProx ();
             ;
             Ant = Atu, Atu = Atu.SeuProx ())
        {
            if (Atu ==  null) break;
            if (F < Atu.SuaInfo ()) break;
        }

        Ant.AssumaProx (new Elem (F, Atu));
    }

    public boolean Possui (float F)
    {
        for (Elem E = this.Prim; E != null; E = E.SeuProx ())
            if (F == E.SuaInfo ()) return true;

        this.Erro = false;
        return false;
    }
 
    public void Descarte (float F)
    {
        Elem Ant, Atu;

        for (Ant = null, Atu = this.Prim;
             ;
             Ant = Atu, Atu = Atu.SeuProx ())
        {
            if (Atu      == null) break;
            if (Atu.SuaInfo () == F   ) break;
        }

        if (Atu == null)
        {
            this.Erro = true;
            return;
        }
       
        if (Ant == null)
            this.Prim = Atu.SeuProx ();
        else
            Ant.AssumaProx (Atu.SeuProx ());

        this.Erro = false;
    }

    public String toString ()
    {
        String R  = "";

        for (Elem E = this.Prim; E != null; E = E.SeuProx ())
           R = R + E.SuaInfo () + (E.SeuProx () == null? "": ", ");

        this.Erro = false;
        return R;           
    }
}