package Listas;

public class ListaCompleta extends Lista
{
    public float Primeiro ()
    {
        if (this.Vazia ())
        {
            this.Erro = true;
            return Float.NaN;
        }

        this.Erro = false;
        return this.Prim.SuaInfo ();
    }

    public void GuardeNoInicio (float F)
    {
        this.Prim = new Elem (F, this.Prim);
        this.Erro = false;
    }

    public void DescartePrimeiro ()
    {
        if (this.Vazia ())
        {
            this.Erro = true;
            return;
        }
        
        this.Prim = this.Prim.SeuProx ();
        this.Erro = false;
    }

    public float Ultimo ()
    {
        if (this.Vazia ())
        {
            this.Erro = true;
            return Float.NaN;
        }

        Elem E;

        for (E = this.Prim; E.SeuProx () != null; E = E.SeuProx ());


        this.Erro = false;
        return E.SuaInfo ();
    }

    public void GuardeNoFinal (float F)
    {
        this.Erro = false;

        if (this.Vazia ())
        {
            this.Prim = new Elem (F, null);
            return;
        }

        Elem E;

        for (E = this.Prim; E.SeuProx  ()!= null; E = E.SeuProx ());

        E.AssumaProx (new Elem (F, null));
    }

    public void DescarteUltimo ()
    {
        if (this.Vazia ())
        {
            this.Erro = true;
            return;
        }

        this.Erro = false;

        if (this.Prim.SeuProx () == null)
        {
            this.Prim = null;
            return;
        }

        Elem E;

        for (E = this.Prim; E.SeuProx().SeuProx () != null; E = E.SeuProx ());

        E.AssumaProx (null);
    }

    public String toString ()
    {
        return '{' + super.toString () + '}';
    }
}